package be.iminds.ilabt.jfed.lowlevel.api.test;

import com.fasterxml.jackson.databind.ObjectMapper;
import io.dropwizard.jackson.Jackson;
import org.testng.annotations.Test;

import java.util.HashMap;
import java.util.Map;

import static org.testng.Assert.*;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.*;

import static org.mockito.Mockito.mock;

public class GPULabTestConfigTest {
    @Test(enabled=true)
    public void checkEmpty() {
        final ObjectMapper MAPPER = Jackson.newObjectMapper();

        Map m = new HashMap();

        GPULabTestConfig conf =
                MAPPER.convertValue(m, GPULabTestConfig.class);

        assertThat(conf, is(notNullValue()));
        assertThat(conf.getGpulabURL(), is(notNullValue()));
        assertThat(conf.getGpulabURL(), startsWith("https://"));
        assertThat(conf.getVersion(), is(equalTo("dev")));
        assertThat(conf.getMinGPUs(), is(equalTo(1)));
        assertThat(conf.getMinCPUs(), is(equalTo(1)));
        assertThat(conf.getMinSlaves(), is(equalTo(1)));
        assertThat(conf.getMinClusters(), is(equalTo(1)));
    }

    @Test(enabled=true)
    public void checkFull() {
        final ObjectMapper MAPPER = Jackson.newObjectMapper();

        Map<String, Object> m = new HashMap<>();
        m.put("gpulabURL", "https://example.com/test");
        m.put("version", "testtest");
        m.put("minGPUs", 5);
        m.put("minCPUs", 10);
        m.put("minSlaves", 2);
        m.put("minClusters", 3);

        GPULabTestConfig conf = MAPPER.convertValue(m, GPULabTestConfig.class);

        assertThat(conf, is(notNullValue()));
        assertThat(conf.getGpulabURL(), is(equalTo("https://example.com/test")));
        assertThat(conf.getVersion(), is(equalTo("testtest")));
        assertThat(conf.getMinGPUs(), is(equalTo(5)));
        assertThat(conf.getMinCPUs(), is(equalTo(10)));
        assertThat(conf.getMinSlaves(), is(equalTo(2)));
        assertThat(conf.getMinClusters(), is(equalTo(3)));
    }
}
