package be.iminds.ilabt.jfed.rspec.model.imutable_impl;

import be.iminds.ilabt.jfed.rspec.model.GeantTestbedType;
import be.iminds.ilabt.jfed.rspec.model.WebVncService;
import be.iminds.ilabt.jfed.util.common.GeniUrn;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;

public class ImmutableGeantTestbedType implements GeantTestbedType {
    private final String name;
    private final String dsl;

    private final GeniUrn componentManagerId;
    private final GeniUrn componentId;
    private final GeniUrn sliverId;

    private final double editorX;
    private final double editorY;

    private final ImmutableVpnService vpnService;
    private final List<WebVncService> webVncServices;

    private static <T> List<T> listInit(List<T> orig) {
        if (orig == null) return null;
        return Collections.unmodifiableList(new ArrayList<>(orig));
    }

    public ImmutableGeantTestbedType(GeantTestbedType orig) {
        this.name = orig.getName();
        this.dsl = orig.getDsl();
        this.componentManagerId = orig.getComponentManagerId();
        this.componentId = orig.getComponentId();
        this.sliverId = orig.getSliverId();

        this.editorX = orig.getEditorX();
        this.editorY = orig.getEditorY();

        this.vpnService = orig.getVpnService() == null ? null : new ImmutableVpnService(orig.getVpnService());
        this.webVncServices = listInit(orig.getWebVncServices());
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(String name) {
        throw new UnsupportedOperationException();
    }

    @Override
    public String getDsl() {
        return dsl;
    }

    @Override
    public void setDsl(String dsl) {
        throw new UnsupportedOperationException();
    }

    @Override
    public GeniUrn getComponentManagerId() {
        return componentManagerId;
    }

    @Override
    public void setComponentManagerId(GeniUrn componentManagerId) {
        throw new UnsupportedOperationException();
    }

    @Override
    public GeniUrn getComponentId() {
        return componentId;
    }

    @Override
    public void setComponentId(GeniUrn componentId) {
        throw new UnsupportedOperationException();
    }

    @Override
    public GeniUrn getSliverId() {
        return sliverId;
    }

    @Override
    public void setSliverId(GeniUrn sliverId) {
        throw new UnsupportedOperationException();
    }

    @Override
    public double getEditorX() {
        return editorX;
    }

    @Override
    public void setEditorX(double editorX) {
        throw new UnsupportedOperationException();
    }

    @Override
    public double getEditorY() {
        return editorY;
    }

    @Override
    public void setEditorY(double editorY) {
        throw new UnsupportedOperationException();
    }

    @Override
    public ImmutableVpnService getVpnService() {
        return vpnService;
    }

    @Override
    public void setVpnService(VpnService vpnService) {
        throw new UnsupportedOperationException();
    }

    @Override
    public List<WebVncService> getWebVncServices() {
        return webVncServices;
    }

    @Override
    public void setWebVncServices(List<WebVncService> webVncServices) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void addWebVncService(WebVncService webVncService) {
        throw new UnsupportedOperationException();
    }

    public static class ImmutableVpnService implements VpnService {
        private final String endpoint;
        private final String username;
        private final String password;

        public ImmutableVpnService(VpnService vpnService) {
            this.endpoint = vpnService.getEndpoint();
            this.username = vpnService.getUsername();
            this.password = vpnService.getPassword();
        }

        @Override
        public String getEndpoint() {
            return endpoint;
        }

        @Override
        public String getUsername() {
            return username;
        }

        @Override
        public String getPassword() {
            return password;
        }
    }

}
